package com.dkha.server.controllers;

import com.dkha.common.fileupload.MinioUtil;
import com.dkha.common.http.HttpUtil;
import com.dkha.common.modules.vo.face.FaceResEntity;
import com.dkha.common.modules.vo.CompareFaceList;
import com.dkha.common.result.CommonResult;
import com.google.gson.Gson;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.*;


@RestController
@RequestMapping("faces")
@Slf4j
public class FaceController extends CommonResult {
    @Resource
    private MinioUtil minioUtil;
    @Value("${api.server.prefix}")
    private String apiServerPrefix;
    @Autowired
    private HttpUtil httpUtil;
    @Autowired
    private Gson gson;
    private  int count ;

    private  Map<String,FaceResEntity> faceRes = new HashMap<>();

    private List<FaceResEntity> facelist = new ArrayList<>();

    private List<CompareFaceList> compareFaceLists = new ArrayList<>();
    public  FaceController(){
        //FaceResEntity  resEntity = new FaceResEntity();
        //resEntity.setTime("jhx");
        // resEntity.setRphoto("http://192.168.60.52:9000/school/face/jhx.jpg");
        //faceRes.put("eYJST7eY2mbnjGZvywPfxg==",resEntity);
    }

    /*@RequestMapping("callback")
    public String callback(HttpServletRequest request) throws IOException {
        try {
        String streamText = RequestUtil.getStreamText(request);
        System.out.println(streamText);
        JSONObject object = JSONObject.parseObject(streamText);
        String str = object.get("photo").toString();
        String xsd =  object.get("confidence").toString();
        byte[] _byte =  new BASE64Decoder().decodeBuffer(str);
        InputStream inputStream = new ByteArrayInputStream(_byte);

        String  object1 =   "http://192.168.1.133:9000/middleware/"+minioUtil.uploadImage(inputStream,"").getString("path");
        System.out.println(object1);
            if( faceRes.get(object.getString("ImageID"))!=null){
                FaceResEntity resEntity =  faceRes.get(object.getString("ImageID"));
                resEntity.setCphoto(object1);
                //resEntity.setXsd(xsd.substring(0,5));
                list.add(resEntity);

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "ok";
    }

    @GetMapping("list")
    public List<FaceResEntity> getList(){
        list.clear();
        //System.out.println("返回list测试:" + list);
        //String testUrl = apiServerPrefix + ApiUrlEnum.FACE_SEARCH.getUrl();
        String testUrl = "http://192.168.1.196:5000/cutimage";
        System.out.println("testurl:"+ testUrl);
        ReturnVO returnVO = (ReturnVO) httpUtil.post(testUrl, null, ReturnVO.class);
        List<FaceResEntity> resEntity = JsonUtil.string2Obj(JsonUtil.obj2String(returnVO.getData()), new TypeReference<List<FaceResEntity>>() {});
        //FaceResEntity  resEntity = new FaceResEntity();
        //resEntity.setName("ceshi");
        //resEntity.setCphoto("http://192.168.1.133:9000/middleware/103/1028345463.jpg");
        for(FaceResEntity res :resEntity) {
            System.out.println("resEntity cphoto:"+ res.getCphoto());
            list.add(res);
        }
        System.out.println("返回list测试:" + list);
        return list;
        //return (List<FaceResEntity>) successResult(list);
    }
*/
    @GetMapping( "returnList")
    public List<FaceResEntity> returnList(){
        System.out.println("开始returnlist");
        System.out.println(facelist.size());
        return facelist;
    }


    //从算法端获取图片列表接口
    @PostMapping("/getList")
    public void getList(
            @RequestBody List<FaceResEntity> resEntities) {
        System.out.println("getlist被请求");
        facelist.clear();
        //System.out.println(resEntities);
        for (FaceResEntity res :resEntities){
            count++;
            facelist.add(res);
        }
        System.out.println(facelist);
        WebSocketContral webSocketContral =new WebSocketContral();
        webSocketContral.sendMessage(gson.toJson(facelist));
        //webSocketContral.sendMessage("发送websocket信息中");
    }

    public  void sendWebsocket1(List<FaceResEntity> onfacelist){
        facelist.clear();
        facelist = onfacelist;
        WebSocketContral webSocketContral =new WebSocketContral();
        System.out.println("facelist"+ facelist);
        System.out.println("GSON" + gson.toJson(facelist));
        webSocketContral.sendMessage(gson.toJson(facelist));
        //webSocketContral.sendMessage("发送websocket信息中");
    }

    public  void sendWebsocket2(List<CompareFaceList> oncompareFacelist){
        compareFaceLists.clear();
        compareFaceLists = oncompareFacelist;
        WebSocketContral webSocketContral =new WebSocketContral();
        webSocketContral.sendMessage(gson.toJson(oncompareFacelist));
        //webSocketContral.sendMessage("发送websocket信息中");
        System.out.println("list:"+ oncompareFacelist);
    }

    @PostMapping("/compareList")
    public void compareList(
            @RequestBody List<CompareFaceList> compareFaceLists ){
//        String compareURL = apiServerPrefix + ApiUrlEnum.ALARMS_POSTURL.getUrl();
//        ReturnVO returnVO = (ReturnVO) httpUtil.post(compareURL, list, ApiVO.class);
//        CompareFaceList compareFaceList = JsonUtil.string2Obj(JsonUtil.obj2String(returnVO.getData()), new TypeReference<CompareFaceList>() {});
//        compareFaceLists.add(compareFaceList);
//        return successResult(compareFaceLists);
        compareFaceLists.clear();
        for(CompareFaceList com: compareFaceLists ){
            compareFaceLists.add(com);
        }
    }

    public List<FaceResEntity> getFacelist() {
        return this.facelist;
    }

    /*    @GetMapping("one")
    public List<String getOne(){
        if(list.isEmpty()){
            return  "";
        }
        return list.get(list.size()-1).getCphoto();
    }*/


}
